
local RDPS_TOOLTIP_DISPLAY = "|cffeda55fClick|r to reset Raid DPS"

--[[local L = GetLocale()
if L == "frFR" then
	RDPS_TOOLTIP_DISPLAY = "|cffeda55fClick|r to reset Raid DPS"
end]]

local RDPS = _G.CreateFrame("Frame", "StatBlock_RaidDPS")
local lbl = "RDPS"
RDPS.obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject(lbl, {value = "0.0", suffix = lbl, text = "0.0"..lbl})
_G.LibStub("AceTimer-3.0"):Embed(RDPS)

local GetTime = _G.GetTime
local band = _G.bit.band
local bor = _G.bit.bor
local format = _G.string.format

local raidDamage = 0
local combatStartTime = 0
local timer = nil

RDPS:RegisterEvent("PLAYER_REGEN_DISABLED")
RDPS:RegisterEvent("PLAYER_REGEN_ENABLED")
RDPS:SetScript("OnEvent", function(_, event, ...)
	RDPS[event](RDPS, ...)
end)

local txt = "%.1f"
function RDPS:Update()
	local dmg = format(txt, raidDamage / (GetTime() - combatStartTime))
	self.obj.text = dmg..lbl
	self.obj.value = dmg
end

local events = {
	SWING_DAMAGE = true,
	RANGE_DAMAGE = true,
	SPELL_DAMAGE = true,
	SPELL_PERIODIC_DAMAGE = true,
	DAMAGE_SHIELD = true,
	DAMAGE_SPLIT = true,
}
local srcRaidFilter = bor(_G.COMBATLOG_OBJECT_AFFILIATION_RAID,
	_G.COMBATLOG_OBJECT_AFFILIATION_PARTY, _G.COMBATLOG_OBJECT_AFFILIATION_MINE
)
function RDPS:COMBAT_LOG_EVENT_UNFILTERED(_, eventType, _, _, sourceFlags, _, _, _, spellID, _, _, damage)
	if not events[eventType] then return end
	if band(sourceFlags, srcRaidFilter) == 0 then return end

	if eventType == "SWING_DAMAGE" then
		damage = spellID
	end

	raidDamage = raidDamage + damage
end

function RDPS:PLAYER_REGEN_DISABLED()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	combatStartTime = GetTime()
	raidDamage = 0
	timer = self:ScheduleRepeatingTimer("Update", 0.2)
end

function RDPS:PLAYER_REGEN_ENABLED()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	self:Update()
	self:CancelTimer(timer, true)
end

function RDPS.obj.OnTooltipShow(tooltip)
	if tooltip and tooltip.AddLine then
		tooltip:AddLine(RDPS_TOOLTIP_DISPLAY)
	end
end

function RDPS.obj.OnClick()
	combatStartTime = GetTime()
	raidDamage = 0
	RDPS.obj.text = "0.0"..lbl
	RDPS.obj.value = "0.0"
end

